## ros-foxy-clpe-ros 0.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(clpe_ros)

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)
find_package(clpe REQUIRED)
find_package(rclcpp REQUIRED)
find_package(image_transport REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(cv_bridge REQUIRED)
find_package(tf2 REQUIRED)
find_package(clpe_ros_msgs REQUIRED)

add_library(${PROJECT_NAME}_lib INTERFACE)
target_include_directories(${PROJECT_NAME}_lib INTERFACE
  ${geometry_msgs_INCLUDE_DIRS}
  ${sensor_msgs_INCLUDE_DIRS}
  ${image_transport_INCLUDE_DIRS}
  ${cv_bridge_INCLUDE_DIRS}
  ${clpe_ros_msgs_INCLUDE_DIRS}
)
target_link_libraries(${PROJECT_NAME}_lib INTERFACE
  clpe::clpe
  rclcpp::rclcpp
  ${geometry_msgs_LIBRARIES}
  ${sensor_msgs_LIBRARIES}
  ${image_transport_LIBRARIES}
  ${cv_bridge_LIBRARIES}
  ${clpe_ros_msgs_LIBRARIES}
)
target_compile_features(${PROJECT_NAME}_lib INTERFACE cxx_std_14)
add_executable(${PROJECT_NAME}
  src/main.cpp)
target_link_libraries(${PROJECT_NAME} PRIVATE ${PROJECT_NAME}_lib)
install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION lib/${PROJECT_NAME})

###############################################################################
# ROS2 component
###############################################################################

include(GenerateExportHeader)
find_package(rclcpp_components REQUIRED)

# Create shared library
add_library(${PROJECT_NAME}_component SHARED
  src/component.cpp)
target_compile_definitions(${PROJECT_NAME}_component
  PRIVATE "COMPOSITION_BUILDING_DLL")
target_include_directories(${PROJECT_NAME}_component PRIVATE
  ${CMAKE_CURRENT_BINARY_DIR}
  ${rclcpp_components_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME}_component
  ${PROJECT_NAME}_lib
  ${rclcpp_components_LIBRARIES})
set_target_properties(${PROJECT_NAME}_component PROPERTIES
  CXX_VISIBILITY_PRESET hidden
  VISIBILITY_INLINES_HIDDEN ON)

# Generate export headers
GENERATE_EXPORT_HEADER(${PROJECT_NAME}_component)

# register component
rclcpp_components_register_nodes(${PROJECT_NAME}_component "clpe::ClpeComponentNode")
set(node_plugins "${node_plugins}clpe::ClpeComponentNode;$<TARGET_FILE:${PROJECT_NAME}_component>\n")
file(GENERATE
  OUTPUT
    "${CMAKE_CURRENT_BINARY_DIR}/test_ament_index/$<CONFIG>/share/ament_index/resource_index/node_plugin/${PROJECT_NAME}"
  CONTENT "${node_plugins}")

# install target
install(TARGETS ${PROJECT_NAME}_component)

###############################################################################

option(CLPE_ROS_BUILD_BENCHMARKS "build benchmarks")
if (${CLPE_ROS_BUILD_BENCHMARKS})
  add_subdirectory(benchmarks)
endif()

install(
  DIRECTORY launch
  DESTINATION share/${PROJECT_NAME})

install(
  FILES fastdds.xml
  DESTINATION share/${PROJECT_NAME})

ament_package()

=== benchmarks/CMakeLists.txt ===
add_executable(latency latency.cpp)
target_include_directories(latency PRIVATE ${sensor_msgs_INCLUDE_DIRS})
target_link_libraries(latency PRIVATE rclcpp::rclcpp ${sensor_msgs_LIBRARIES})
# always build in release mode
separate_arguments(BUILD_FLAGS NATIVE_COMMAND ${CMAKE_CXX_FLAGS_RELEASE})
target_compile_options(latency PRIVATE ${BUILD_FLAGS})

=== debian/changelog ===
ros-foxy-clpe-ros (0.1.1-1focal) focal; urgency=high

  * remove EEPROM

 -- Dongwoo Sun <dwsun@can-lab.co.kr>  Wed, 24 Aug 2022 07:00:00 -0000

ros-foxy-clpe-ros (0.1.0-1focal) focal; urgency=high

  * Provides ROS 2 driver for CANLAB CLPE-G-NVP2650D vision system
  * Support ROS 2 Foxy and ROS 2 Galactic
  * By default the driver will publish three topics for each camera X.
    * /clpe/cam_X/image_raw: The raw image published as sensor_msgs::msg::Image. The default encoding is yuv422. For other supported encodings, see Configuration.
    * /clpe/cam_X/camera_info: The intrinsics of the camera published as a sensor_msgs::msg::CameraInfo message.
    * /clpe/cam_X/clpe_camera_info: The intrinsics of the camera published as a clpe_ros_msgs::msg::ClpeCameraInfo message.
  * Contributors: Teo Koon Peng, Yadunund Vijay

 -- Dongwoo Sun <dwsun@can-lab.co.kr>  Wed, 20 Apr 2022 07:00:00 -0000

=== debian/control ===
Source: ros-foxy-clpe-ros
Section: misc
Priority: optional
Maintainer: Dongwoo Sun <dwsun@can-lab.co.kr>
Build-Depends: debhelper (>= 9.0.0), python3-colcon-common-extensions, ros-foxy-ament-cmake, ros-foxy-clpe, ros-foxy-clpe-ros-msgs, ros-foxy-cv-bridge, ros-foxy-geometry-msgs, ros-foxy-image-transport, ros-foxy-rclcpp, ros-foxy-rclcpp-components, ros-foxy-sensor-msgs, ros-foxy-tf2, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-clpe-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-clpe, ros-foxy-clpe-ros-msgs, ros-foxy-cv-bridge, ros-foxy-geometry-msgs, ros-foxy-image-transport, ros-foxy-rclcpp, ros-foxy-rclcpp-components, ros-foxy-sensor-msgs, ros-foxy-tf2, ros-foxy-ros-workspace
Description: ROS driver for CANLAB CLPE-G-NVP2650D

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-clpe-ros//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
